/****************************************************************************
 * ren.h
 * Author Joel Welling
 * Copyright 1989, Pittsburgh Supercomputing Center, Carnegie Mellon University
 *
 * Permission use, copy, and modify this software and its documentation
 * without fee for personal use or use within your organization is hereby
 * granted, provided that the above copyright notice is preserved in all
 * copies and that that copyright and this permission notice appear in
 * supporting documentation.  Permission to redistribute this software to
 * other organizations or individuals is not granted;  that must be
 * negotiated with the PSC.  Neither the PSC nor Carnegie Mellon
 * University make any representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 *****************************************************************************/
/*
This file contains definitions of entry points supplied by renderer drivers.
*/

extern void ren_dump();
extern void ren_sphere();
extern void ren_cylinder();
extern void ren_torus();
extern void ren_text();
extern void ren_polyline();
extern void ren_polymarker();
extern void ren_polygon();
extern void ren_triangle();
extern void ren_mesh();
extern void ren_bezier();
extern void ren_gob();
extern void ren_light();
extern void ren_ambient();
extern void ren_camera();
extern void ren_render();
extern void ren_traverselights();
extern void ren_free();
extern void ren_setup();
extern void ren_reset();
extern void ren_shutdown();
extern char *ren_def_material();
extern void ren_free_material();
